/*
** realtech VR, Inc.
** http://www.realtech-vr.com
** Copyright (c) 2000-2002.  All Rights Reserved
**
** Source code from realtech VR is supplied under the terms of a license
** agreement and may not be copied or disclosed except in accordance with the
** terms of that agreement.  The various license agreements may be found at
** the realtech VR web site.  This file is Open Source
**
** FREE SOURCE CODE
** http://www.realtech-vr.com
**
** OpenGL 1.3 extensions
**
** Additional extensions (c) Copyright 1998 S3 Incorporated.
** Additional extensions (c) Copyright 2001 NVidia Corp.
** Additional extensions (c) Copyright 2000 3Dfx Interactive.
** Additional extensions (c) Copyright 2001-2002 ATI Incorporated.
**
*/
// #include "stdafx.h" // Uncomment this for pre-compiled support.

#define _EXPORT_WGLEXT

#if (defined(_WIN32) || defined(__WIN32__))
#include <windows.h>

#ifdef _USE_MCD
#define WGLGETPROC( type, func) func = (type) mcdGetProcAddress(#func); assert(func)
#define WGLGETPROCNOFAIL(type, func) func = (type) mcdGetProcAddress(#func);
#else
#define WGLGETPROC( type, func) func = (type) wglGetProcAddress(#func); assert(func)
#define WGLGETPROCNOFAIL(type, func) func = (type) wglGetProcAddress(#func);
#endif

#elif defined __linux__

#define WGLGETPROC( type, func) func = (type) glXGetProcAddressARB(#func); assert(func)
#define WGLGETPROCNOFAIL(type, func) func = (type) glXGetProcAddressARB(#func);

#elif defined macintosh

// pure undocumented extension
#ifndef GL_MAC_GET_PROC_ADDRESS_NV
#define GL_MAC_GET_PROC_ADDRESS_NV 0x84FC
#endif

typedef void *(*PFUNCMACGETPROCADDRESSNVFUNC)(char *string);
PFUNCMACGETPROCADDRESSNVFUNC	glMacGetProcAddressNV;
#define WGLGETPROC( type, func) func = (type) glMacGetProcAddressNV(#func); assert(func)
#define WGLGETPROCNOFAIL(type, func) func = (type) glMacGetProcAddressNV(#func);

#endif

#include <assert.h>
#include "wglext.h"

#if (defined(_WIN32) || defined(__WIN32__))
// ChoosePixelFormatEX

GLint ChoosePixelFormatEx(HDC pHdc, GLint *pBpp, GLint *pDepth, GLint *pStencil, GLint *pDbl, GLint *pAcc, GLint *pDib)
{
	GLint wbpp		= pBpp		== NULL ?  -1 : *pBpp;
	GLint wdepth	= pDepth	== NULL ?  16 : *pDepth;
	GLint wstencil  = pStencil	== NULL ?   0 : *pDepth;
	GLint wdbl		= pDbl		== NULL ?  -1 : *pDbl;
	GLint wacc		= pAcc		== NULL ?	1 : *pAcc;
	GLint wdib		= pDib		== NULL ? - 1 : *pDib;

	PIXELFORMATDESCRIPTOR pfd;
	ZeroMemory(&pfd, sizeof(pfd));

	pfd.nSize = sizeof(pfd);
	pfd.nVersion = 1;

	GLint num = DescribePixelFormat(pHdc, 1, sizeof(pfd), &pfd);
	if(num == 0)
		return 0;

	GLuint maxqual = 0;
	GLint maxindex = 0;
	GLint max_bpp, max_depth, max_dbl, max_acc, max_dib, max_stencil;

	for(GLint i = 1; i <= num; i++)
	{
		ZeroMemory(&pfd, sizeof(pfd));
		pfd.nSize = sizeof(pfd);
		pfd.nVersion = 1;

		DescribePixelFormat(pHdc, i, sizeof(pfd), &pfd);

		GLint bpp = pfd.cColorBits;
		GLint depth = pfd.cDepthBits;
		GLint stencil = pfd.cStencilBits;
		bool pal = (pfd.iPixelType == PFD_TYPE_COLORINDEX);
		bool mcd = ((pfd.dwFlags & PFD_GENERIC_FORMAT) && (pfd.dwFlags & PFD_GENERIC_ACCELERATED));
		bool soft = ((pfd.dwFlags & PFD_GENERIC_FORMAT) &&!(pfd.dwFlags & PFD_GENERIC_ACCELERATED));
		bool icd = (!(pfd.dwFlags & PFD_GENERIC_FORMAT) &&!(pfd.dwFlags & PFD_GENERIC_ACCELERATED));
		bool opengl = (pfd.dwFlags & PFD_SUPPORT_OPENGL) ? true :false;
		bool window = (pfd.dwFlags & PFD_DRAW_TO_WINDOW) ? true :false;
		bool bitmap = (pfd.dwFlags & PFD_DRAW_TO_BITMAP) ? true :false;
		bool dbuff	= (pfd.dwFlags & PFD_DOUBLEBUFFER);		

		GLuint q = 0;
		if(opengl && window)
			q += 0x10000;		
		if(wdepth == -1 || (wdepth > 0 && depth > 0))
			q += 0x8000;
		if(wstencil == -1 || (wstencil > 0 && stencil > 0))
			q += 0x4000;
		if(wdbl == -1 || (wdbl == 0 && !dbuff) || (wdbl == 1 && dbuff))
			q += 0x2000;
		if(wacc == -1 || (wacc == 0 && soft) || (wacc == 1 && (mcd ||icd)))
			q += 0x1000;
		if(mcd || icd)
			q += 0x0040;
		if(icd)
			q += 0x0002;
		if(wbpp == -1 || (wbpp == bpp))
			q += 0x0800;
		if((wdib == -1) || (wdib == 0 && !bitmap) || (wdbl == 1 && bitmap))
			q += 0x10000;
		if(bpp >= 16)
			q += 0x0020;
		if(bpp == 16)
			q += 0x0008;
		if(wdepth == -1 || (wdepth == depth))
			q += 0x0400;
		
		if(depth >= 16)
			q += 0x0010;
		if(depth == 16)
			q += 0x0004;
		if(!pal)
			q += 0x0080;
		
		if(q > maxqual)
		{
			maxqual = q;
			maxindex = i;
			max_bpp = bpp;
			max_depth = depth;
			max_stencil = stencil;
			max_dbl = dbuff ? 1 : 0;
			max_acc = soft ? 0 : 1;
			max_dib = bitmap ? 1 : 0;
		}
	}
	if(maxindex == 0)
		return maxindex;

	if(pBpp != NULL)
		*pBpp = max_bpp;
	if(pDepth != NULL)
		*pDepth = max_depth;
	if(pStencil != NULL)
		*pStencil = max_stencil;
	if(pDbl != NULL)
		*pDbl = max_dbl;
	if(pAcc != NULL)
		*pAcc = max_acc;
	if(pDib !=NULL)
		*pDib = max_dib;

	return maxindex;
}

void wglQueryDisplayModes(DEVMODE **ppmode, GLint *pNumModes)
{
	GLint n = 0;
	DEVMODE  devmode;
	devmode.dmSize = sizeof(DEVMODE);

	while (EnumDisplaySettings(NULL, n, &devmode))
		n++;

	if (pNumModes) 
		*pNumModes = n;

	/* fill an array with all the devmodes so we don't have to keep
		grabbing 'em. */
	if (ppmode)
	{
		DEVMODE * p = new DEVMODE[ n + 1];
		n = 0;
		p[n].dmSize = sizeof(DEVMODE);

		while (EnumDisplaySettings(NULL, n, p + n))
		{
			n++;
			p[n].dmSize = sizeof(DEVMODE);
		}
		*ppmode = p;
	}	
	return;
}


// ARB Pixel Format
GLint wglIsExtensionSupportedARB(HDC hdc, const char *extension)
{
	static const char *extensions = NULL;
	const char *start;
	char *where, *terminator;
	if (!extension)
	{
		extensions = NULL;
		return 1;
	}
	where = strchr(extension, ' ');
	if (where || *extension == '\0')
		return 0;
	if (!extensions)
		extensions = wglGetExtensionsStringARB(hdc);
	start = extensions;
	for (;;) {
		where = strstr((const char *) start, extension);
		if (!where)
			break;
		terminator = where + strlen(extension);
		if (where == start || *(where - 1) == ' ') {
			if (*terminator == ' ' || *terminator == '\0') {
				return 1;
			}
		}
		start = terminator;
	}
	return 0;
}

int wglGetProcAddressesARB(HDC hDC)
{
	int bits = GetDeviceCaps(hDC, BITSPIXEL);
	static HGLRC hRC = NULL;						// Permanent Rendering Context
	static PIXELFORMATDESCRIPTOR pfd =				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR), 				// Size Of This Pixel Format Descriptor
		1, 											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER, 							// Must Support Double Buffering
		PFD_TYPE_RGBA, 								// Request An RGBA Format
		bits, 										// Select Our Color Depth
		0, 0, 0, 0, 0, 0, 							// Color Bits Ignored
		0, 											// No Alpha Buffer
		0, 											// Shift Bit Ignored
		0, 											// No Accumulation Buffer
		0, 0, 0, 0, 								// Accumulation Bits Ignored
		0,											// 16Bit Z-Buffer (Depth Buffer)  
		0, 											// No Stencil Buffer
		0, 											// No Auxiliary Buffer
		PFD_MAIN_PLANE, 							// Main Drawing Layer
		0, 											// Reserved
		0, 0, 0 									// Layer Masks Ignored
	};
	int PixelFormat;
	if (!(PixelFormat=ChoosePixelFormat(hDC, &pfd))) // Did Windows Find A Matching Pixel Format?
		goto killer;	

	if(!SetPixelFormat(hDC, PixelFormat, &pfd))		// Are We Able To Set The Pixel Format?
		goto killer;

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
		goto killer;
	
	if(!wglMakeCurrent(hDC, hRC))					// Try To Activate The Rendering Context
		goto killer;
													// Get extensions
	WGLGETPROCNOFAIL(PFNWGLGETEXTENSIONSSTRINGARBPROC, wglGetExtensionsStringARB);
	WGLGETPROCNOFAIL(PFNWGLGETEXTENSIONSSTRINGEXTPROC, wglGetExtensionsStringEXT);

	if (wglGetExtensionsStringARB)
	{		
		if (wglIsExtensionSupportedARB(hDC, "WGL_ARB_pixel_format"))
		{
			WGLGETPROC( PFNWGLGETPIXELFORMATATTRIBIVARBPROC, wglGetPixelFormatAttribivARB);
			WGLGETPROC( PFNWGLGETPIXELFORMATATTRIBFVARBPROC, wglGetPixelFormatAttribfvARB);
			WGLGETPROC( PFNWGLCHOOSEPIXELFORMATARBPROC,	wglChoosePixelFormatARB);
		}
		
		if (wglIsExtensionSupportedARB(hDC, "WGL_ARB_pbuffer"))
		{
			WGLGETPROC( PFNWGLCREATEPBUFFERARBPROC, wglCreatePbufferARB);
			WGLGETPROC( PFNWGLGETPBUFFERDCARBPROC, wglGetPbufferDCARB);
			WGLGETPROC( PFNWGLRELEASEPBUFFERDCARBPROC, wglReleasePbufferDCARB);
			WGLGETPROC( PFNWGLDESTROYPBUFFERARBPROC, wglDestroyPbufferARB);
			WGLGETPROC( PFNWGLQUERYPBUFFERARBPROC, wglQueryPbufferARB);
		}

		if (wglIsExtensionSupportedARB(hDC, "WGL_ARB_render_texture"))
		{
			WGLGETPROC( PFNWGLBINDTEXIMAGEARBPROC, wglBindTeximageARB);
			WGLGETPROC( PFNWGLRELEASETEXIMAGEARBPROC, wglReleaseTeximageARB);		
			WGLGETPROC( PFNWGLSETPBUFFERATTRIBARBPROC, wglSetPbufferAttribARB);
		}
		
		if (wglIsExtensionSupportedARB(hDC, "WGL_ARB_multisample"))
		{
			WGLGETPROC( PFNGLSAMPLECOVERAGEARBPROC,	glSampleCoverageARB);
		}
	}
	else
	if (wglGetExtensionsStringEXT)
	{
		if (wglIsExtensionSupported("WGL_EXT_pixel_format"))
		{
			WGLGETPROC( PFNWGLGETPIXELFORMATATTRIBIVEXT, wglGetPixelFormatAttribivEXT);
			WGLGETPROC( PFNWGLGETPIXELFORMATATTRIBFVEXT, wglGetPixelFormatAttribfvEXT);
			WGLGETPROC( PFNWGLCHOOSEPIXELFORMATEXT,	wglChoosePixelFormatEXT);		
		}
		
		if (wglIsExtensionSupported("WGL_EXT_pbuffer"))
		{
			WGLGETPROC( PFNWGLCREATEPBUFFEREXT, wglCreatePbufferEXT);
			WGLGETPROC( PFNWGLGETPBUFFERDCEXT, wglGetPbufferDCEXT);
			WGLGETPROC( PFWGLRELEASEPBUFFERDCEXT, wglReleasePbufferDCEXT);
			WGLGETPROC( PFWGLDESTROYPBUFFEREXT, wglDestroyPbufferEXT);
			WGLGETPROC( PFWGLQUERYPBUFFEREXT, wglQueryPbufferEXT);
		}
	}
killer:
  	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL, NULL)) 				// Are We Able To Release The DC And RC Contexts?
		{
		}

		if (!wglDeleteContext(hRC)) 					// Are We Able To Delete The RC?
		{
		}
		hRC = NULL;										// Set RC To NULL
	}	
	return -1;
	
}


#endif // __WIN32__

// public extension

GLint wglIsExtensionSupported(const char *extension)
{
	static const GLubyte *extensions = NULL;
	const GLubyte *start;
	GLubyte *where, *terminator;
	if (!extension)
	{
		extensions = NULL;
		return 1;
	}
	where = (GLubyte *) strchr(extension, ' ');
	if (where || *extension == '\0')
		return 0;
	if (!extensions)
		extensions = glGetString(GL_EXTENSIONS);
	start = extensions;
	for (;;) {
		where = (GLubyte *) strstr((const char *) start, extension);
		if (!where)
			break;
		terminator = where + strlen(extension);
		if (where == start || *(where - 1) == ' ') {
			if (*terminator == ' ' || *terminator == '\0') {
				return 1;
			}
		}
		start = terminator;
	}
	return 0;
}

void wglGetProcAddresses()
{
	// win32
#ifdef _WIN32
	if (wglIsExtensionSupported("WGL_EXT_swap_control"))
	{
		WGLGETPROC( PFNWGLSWAPINTERVALEXTPROC, wglSwapIntervalEXT);
		WGLGETPROC( PFNWGLGETSWAPINTERVALEXTPROC, wglGetSwapIntervalEXT);		
	}

	if (wglIsExtensionSupported("GL_WIN_swap_hint"))
	{
		WGLGETPROC( PFNGLADDSWAPHINTRECTWINPROC, glAddSwapHintRectWIN);
	}
		
#elif defined macintosh
	glGetPointerv(GL_MAC_GET_PROC_ADDRESS_NV, (GLvoid*) &glMacGetProcAddressNV);
	if (!glMacGetProcAddressNV)
	{
		// Bad luck
	}
#endif

	// 3dfx
	if (wglIsExtensionSupported("GL_3DFX_tbuffer"))
	{
		 WGLGETPROC( PGNGLTBUFFERMASK3DFX, glTbufferMask3DFX);
	}

	// ATI
	if (wglIsExtensionSupported("GL_ATI_vertex_array_object"))
	{
         WGLGETPROC( PFNGLNEWOBJECTBUFFERATIPROC, glNewObjectBufferATI);
		 WGLGETPROC( PFNGLISOBJECTBUFFERATIPROC, glIsObjectBufferATI);
		 WGLGETPROC( PFNGLUPDATEOBJECTBUFFERATIPROC, glUpdateObjectBufferATI); 
		 WGLGETPROC( PFNGLGETOBJECTBUFFERFVATIPROC, glGetObjectBufferfvATI);
		 WGLGETPROC( PFNGLGETOBJECTBUFFERIVATIPROC, glGetObjectBufferivATI);
		 WGLGETPROC( PFNGLFREEOBJECTBUFFERATIPROC, glFreeObjectBufferATI);
		 WGLGETPROC( PFNGLARRAYOBJECTATIPROC, glArrayObjectATI);
		 WGLGETPROC( PFNGLGETARRAYOBJECTFVATIPROC, glGetArrayObjectfvATI);
		 WGLGETPROC( PFNGLGETARRAYOBJECTIVATIPROC, glGetArrayObjectivATI);
		 WGLGETPROC( PFNGLVARIANTARRAYOBJECTATIPROC, glVariantArrayObjectATI);
		 WGLGETPROC( PFNGLGETVARIANTARRAYOBJECTFVATIPROC, glGetVariantArrayObjectfvATI);
		 WGLGETPROC( PFNGLGETVARIANTARRAYOBJECTIVATIPROC, glGetVariantArrayObjectivATI);

		if (wglIsExtensionSupported("GL_ATI_element_array"))
		{
			WGLGETPROC( PFNGLELEMENTPOINTERATIPROC,	glElementPointerATI);
			WGLGETPROC( PFNGLDRAWELEMENTARRAYATIPROC, glDrawElementArrayATI);
			WGLGETPROC( PFNGLDRAWRANGEELEMENTARRAYATIPROC, glDrawRangeElementArrayATI);			
		}
	
		// pure undocumented function, courtesy ATI Technologies
		if (wglIsExtensionSupported("GL_ATI_map_object_buffer"))
		{
			WGLGETPROC( PFNGLMAPOBJECTBUFFERATI, glMapObjectBufferATI);
			WGLGETPROC( PFNGLUNMAPOBJECTBUFFERATI, glUnmapObjectBufferATI);
		}
	}
	
	if (wglIsExtensionSupported("GL_ATI_fragment_shader"))
	{
	     WGLGETPROC( PFNGLGENFRAGMENTSHADERSATIPROC, glGenFragmentShadersATI);
		 WGLGETPROC( PFNGLBINDFRAGMENTSHADERATIPROC, glBindFragmentShaderATI);
		 WGLGETPROC( PFNGLDELETEFRAGMENTSHADERATIPROC, glDeleteFragmentShaderATI);
		 WGLGETPROC( PFNGLBEGINFRAGMENTSHADERATIPROC, glBeginFragmentShaderATI);
		 WGLGETPROC( PFNGLENDFRAGMENTSHADERATIPROC, glEndFragmentShaderATI);
		 WGLGETPROC( PFNGLPASSTEXCOORDATIPROC, glPassTexCoordATI);
		 WGLGETPROC( PFNGLSAMPLEMAPATIPROC, glSampleMapATI);
		 WGLGETPROC( PFNGLCOLORFRAGMENTOP1ATIPROC, glColorFragmentOp1ATI);
		 WGLGETPROC( PFNGLCOLORFRAGMENTOP2ATIPROC, glColorFragmentOp2ATI);
		 WGLGETPROC( PFNGLCOLORFRAGMENTOP3ATIPROC, glColorFragmentOp3ATI);
		 WGLGETPROC( PFNGLALPHAFRAGMENTOP1ATIPROC, glAlphaFragmentOp1ATI);
		 WGLGETPROC( PFNGLALPHAFRAGMENTOP2ATIPROC, glAlphaFragmentOp2ATI);
		 WGLGETPROC( PFNGLALPHAFRAGMENTOP3ATIPROC, glAlphaFragmentOp3ATI);
		 WGLGETPROC( PFNGLSETFRAGMENTSHADERCONSTANTATIPROC, glSetFragmentShaderConstantATI);
	}

	if (wglIsExtensionSupported("GL_ATI_envmap_bumpmap"))
	{
		WGLGETPROC( PFNGLTEXBUMPPARAMETERIVATIPROC, glTexBumpParameterivATI);
		WGLGETPROC( PFNGLTEXBUMPPARAMETERFVATIPROC, glTexBumpParameterfvATI);
		WGLGETPROC( PFNGLGETTEXBUMPPARAMETERIVATIPROC, glGetTexBumpParameterivATI);
		WGLGETPROC( PFNGLGETTEXBUMPPARAMETERFVATIPROC, glGetTexBumpParameterfvATI);
	}

	if (wglIsExtensionSupported("GL_ATI_pn_triangles"))
	{
		WGLGETPROC( PFNGLPNTRIANGLESIATIPROC, glPNTrianglesiATI);
		WGLGETPROC( PFNGLPNTRIANGLESFATIPROC, glPNTrianglesfATI);
	}

	// EXT
	if (wglIsExtensionSupported("GL_EXT_separate_specular_color"))
	{
		WGLGETPROC( PFNGLSECONDARYCOLOR3UBVEXTPROC, glSecondaryColor3ubvEXT);		
	}

	if (wglIsExtensionSupported("GL_EXT_fog_coord"))
	{
		WGLGETPROC ( PFNGLFOGCOORDFEXTPROC, glFogCoordfEXT);		
	}

	if (wglIsExtensionSupported("GL_EXT_paletted_texture"))
	{
		WGLGETPROC( PFNGLCOLORTABLEEXTPROC, glColorTableEXT);
	}

#ifndef GL_VERSION_1_2
    if (wglIsExtensionSupported("GL_EXT_compiled_vertex_array")) 
	{
        WGLGETPROC( PFNGLLOCKARRAYSEXTPROC,	glLockArraysEXT);
		WGLGETPROC( PFNGLUNLOCKARRAYSEXTPROC, glUnlockArraysEXT);
    }
#endif

	if (wglIsExtensionSupported("GL_EXT_draw_range_elements")) 
	{
		WGLGETPROC( PFNGLDRAWRANGEELEMENTSEXTPROC, glDrawRangeElementsEXT);
	}

	if (wglIsExtensionSupported("GL_EXT_vertex_shader"))
	{
		WGLGETPROC( PFNGLBEGINVERTEXSHADEREXTPROC, glBeginVertexShaderEXT);
		WGLGETPROC( PFNGLENDVERTEXSHADEREXTPROC, glEndVertexShaderEXT);
		WGLGETPROC( PFNGLBINDVERTEXSHADEREXTPROC, glBindVertexShaderEXT);
		WGLGETPROC( PFNGLGENVERTEXSHADERSEXTPROC, glGenVertexShadersEXT);
		WGLGETPROC( PFNGLDELETEVERTEXSHADEREXTPROC, glDeleteVertexShaderEXT);
		WGLGETPROC( PFNGLSHADEROP1EXTPROC, glShaderOp1EXT);
		WGLGETPROC( PFNGLSHADEROP2EXTPROC, glShaderOp2EXT); 
		WGLGETPROC( PFNGLSHADEROP3EXTPROC, glShaderOp3EXT);
		WGLGETPROC( PFNGLSWIZZLEEXTPROC, glSwizzleEXT);
		WGLGETPROC( PFNGLWRITEMASKEXTPROC, glWriteMaskEXT);
		WGLGETPROC( PFNGLINSERTCOMPONENTEXTPROC, glInsertComponentEXT);
		WGLGETPROC( PFNGLEXTRACTCOMPONENTEXTPROC, glExtractComponentEXT);
		WGLGETPROC( PFNGLGENSYMBOLSEXTPROC, glGenSymbolsEXT);
		WGLGETPROC( PFNGLSETINVARIANTEXTPROC, glSetInvariantEXT);
		WGLGETPROC( PFNGLSETLOCALCONSTANTEXTPROC, glSetLocalConstantEXT);
		WGLGETPROC( PFNGLVARIANTBVEXTPROC, glVariantbvEXT);
		WGLGETPROC( PFNGLVARIANTSVEXTPROC, glVariantsvEXT);
		WGLGETPROC( PFNGLVARIANTIVEXTPROC, glVariantivEXT);
		WGLGETPROC( PFNGLVARIANTFVEXTPROC, glVariantfvEXT);
		WGLGETPROC( PFNGLVARIANTDVEXTPROC, glVariantdvEXT);
		WGLGETPROC( PFNGLVARIANTUBVEXTPROC, glVariantubvEXT);
		WGLGETPROC( PFNGLVARIANTUSVEXTPROC, glVariantusvEXT);
		WGLGETPROC( PFNGLVARIANTUIVEXTPROC, glVariantuivEXT);
		WGLGETPROC( PFNGLVARIANTPOINTEREXTPROC, glVariantPointerEXT);
		WGLGETPROC( PFNGLENABLEVARIANTCLIENTSTATEEXTPROC, glEnableVariantClientStateEXT);
		WGLGETPROC( PFNGLDISABLEVARIANTCLIENTSTATEEXTPROC, glDisableVariantClientStateEXT);
		WGLGETPROC( PFNGLBINDLIGHTPARAMETEREXTPROC, glBindLightParameterEXT);
		WGLGETPROC( PFNGLBINDMATERIALPARAMETEREXTPROC, glBindMaterialParameterEXT);
		WGLGETPROC( PFNGLBINDTEXGENPARAMETEREXTPROC, glBindTexGenParameterEXT);
		WGLGETPROC( PFNGLBINDTEXTUREUNITPARAMETEREXTPROC, glBindTextureUnitParameterEXT);
		WGLGETPROC( PFNGLBINDPARAMETEREXTPROC, glBindParameterEXT);
		WGLGETPROC( PFNGLISVARIANTENABLEDEXTPROC, glIsVariantEnabledEXT);
		WGLGETPROC( PFNGLGETVARIANTBOOLEANVEXTPROC, glGetVariantBooleanvEXT);
		WGLGETPROC( PFNGLGETVARIANTINTEGERVEXTPROC, glGetVariantIntegervEXT);
		WGLGETPROC( PFNGLGETVARIANTFLOATVEXTPROC, glGetVariantFloatvEXT);
		WGLGETPROC( PFNGLGETVARIANTPOINTERVEXTPROC, glGetVariantPointervEXT);
		WGLGETPROC( PFNGLGETINVARIANTBOOLEANVEXTPROC, glGetInvariantBooleanvEXT);
		WGLGETPROC( PFNGLGETINVARIANTINTEGERVEXTPROC, glGetInvariantIntegervEXT);
		WGLGETPROC( PFNGLGETINVARIANTFLOATVEXTPROC, glGetInvariantFloatvEXT);
		WGLGETPROC( PFNGLGETLOCALCONSTANTBOOLEANVEXTPROC, glGetLocalConstantBooleanvEXT);
		WGLGETPROC( PFNGLGETLOCALCONSTANTINTEGERVEXTPROC, glGetLocalConstantIntegervEXT);
		WGLGETPROC( PFNGLGETLOCALCONSTANTFLOATVEXTPROC, glGetLocalConstantFloatvEXT);
	}	

	if (wglIsExtensionSupported("GL_EXT_vertex_weighting"))
	{
		WGLGETPROC( PFNGLVERTEXWEIGHTFEXTPROC, glVertexWeightfEXT);
		WGLGETPROC( PFNGLVERTEXWEIGHTFVEXTPROC,	glVertexWeightfvEXT);
		WGLGETPROC( PFNGLVERTEXWEIGHTPOINTEREXTPROC, glVertexWeightPointerEXT);
	}

	// ARB
	if (wglIsExtensionSupported("GL_ARB_multitexture"))
	{
		WGLGETPROC( PFNGLACTIVETEXTUREARBPROC, glActiveTextureARB);
		WGLGETPROC( PFNGLMULTITEXCOORD2FARBPROC, glMultiTexCoord2fARB);
		WGLGETPROC( PFNGLMULTITEXCOORD4FARBPROC, glMultiTexCoord4fARB);
		WGLGETPROC( PFNGLMULTITEXCOORD2FVARBPROC, glMultiTexCoord2fvARB);
		WGLGETPROC( PFNGLMULTITEXCOORD4FVARBPROC, glMultiTexCoord4fvARB);
		WGLGETPROC( PFNGLCLIENTACTIVETEXTUREARBPROC, glClientActiveTextureARB);	
	}

	if (wglIsExtensionSupported("GL_ARB_texture_compression"))
	{
		WGLGETPROC( PFNGLCOMPRESSEDTEXIMAGE1DARB,glCompressedTexImage1DARB);
		WGLGETPROC( PFNGLCOMPRESSEDTEXIMAGE2DARB, glCompressedTexImage2DARB);
		WGLGETPROC( PFNGLCOMPRESSEDTEXIMAGE3DARB, glCompressedTexImage3DARB);
		WGLGETPROC( PFNGLGETCOMPRESSEDTEXIMAGEARB, glGetCompressedTexImageARB);		
	}

	if (wglIsExtensionSupported("GL_ARB_transpose_matrix"))
	{
		WGLGETPROC( PFNGLLOADTRANSPOSEMATRIXFARB, glLoadTransposeMatrixfARB);
		WGLGETPROC( PFNGLMULTTRANSPOSEMATRIXFARB, glMultTransposeMatrixfARB);	
	}

	if (wglIsExtensionSupported("GL_ARB_vertex_blend"))
	{
		WGLGETPROC( PFNGLWEIGHTBVARBPROC, glWeightbvARB);
		WGLGETPROC( PFNGLWEIGHTSVARBPROC, glWeightsvARB);
		WGLGETPROC( PFNGLWEIGHTIVARBPROC, glWeightivARB);
		WGLGETPROC( PFNGLWEIGHTFVARBPROC, glWeightfvARB);
		WGLGETPROC( PFNGLWEIGHTDVARBPROC, glWeightdvARB);
		WGLGETPROC( PFNGLWEIGHTUBVARBPROC, glWeightubvARB);
		WGLGETPROC( PFNGLWEIGHTUSVARBPROC, glWeightusvARB);
		WGLGETPROC( PFNGLWEIGHTUIVARBPROC, glWeightuivARB);
		WGLGETPROC( PFNGLWEIGHTPOINTERARBPROC, glWeightPointerARB);
		WGLGETPROC( PFNGLVERTEXBLENDARBPROC, glVertexBlendARB);
	}		

	// NV
	if (wglIsExtensionSupported("GL_NV_vertex_program"))
	{ 
		WGLGETPROC( PFNGLBINDPROGRAMNVPROC, glBindProgramNV);
		WGLGETPROC( PFNGLDELETEPROGRAMSNVPROC, glDeleteProgramsNV);
		WGLGETPROC( PFNGLEXECUTEPROGRAMNVPROC, glExecuteProgramNV);
		WGLGETPROC( PFNGLGENPROGRAMSNVPROC, glGenProgramsNV);
		WGLGETPROC( PFNGLAREPROGRAMSRESIDENTNVPROC, glAreProgramsResidentNV);
		WGLGETPROC( PFNGLREQUESTRESIDENTPROGRAMSNVPROC, glRequestResidentProgramsNV);
		WGLGETPROC( PFNGLGETPROGRAMPARAMETERFVNVPROC, glGetProgramParameterfvNV);
		WGLGETPROC( PFNGLGETPROGRAMPARAMETERDVNVPROC, glGetProgramParameterdvNV);
		WGLGETPROC( PFNGLGETPROGRAMIVNVPROC, glGetProgramivNV);
		WGLGETPROC( PFNGLGETPROGRAMSTRINGNVPROC, glGetProgramStringNV);
		WGLGETPROC( PFNGLGETTRACKMATRIXIVNVPROC, glGetTrackMatrixivNV);
		WGLGETPROC( PFNGLGETVERTEXATTRIBDVNVPROC, glGetVertexAttribdvNV);
		WGLGETPROC( PFNGLGETVERTEXATTRIBFVNVPROC, glGetVertexAttribfvNV);
		WGLGETPROC( PFNGLGETVERTEXATTRIBIVNVPROC, glGetVertexAttribivNV);
		WGLGETPROC( PFNGLGETVERTEXATTRIBPOINTERVNVPROC, glGetVertexAttribPointervNV);
		WGLGETPROC( PFNGLISPROGRAMNVPROC, glIsProgramNV);
		WGLGETPROC( PFNGLLOADPROGRAMNVPROC, glLoadProgramNV);
		WGLGETPROC( PFNGLPROGRAMPARAMETER4FNVPROC, glProgramParameter4fNV);
		WGLGETPROC( PFNGLPROGRAMPARAMETER4DNVPROC, glProgramParameter4dNV);
		WGLGETPROC( PFNGLPROGRAMPARAMETER4DVNVPROC, glProgramParameter4dvNV);
		WGLGETPROC( PFNGLPROGRAMPARAMETER4FVNVPROC, glProgramParameter4fvNV);
		WGLGETPROC( PFNGLPROGRAMPARAMETERS4DVNVPROC, glProgramParameters4dvNV);
		WGLGETPROC( PFNGLPROGRAMPARAMETERS4FVNVPROC, glProgramParameters4fvNV);
		WGLGETPROC( PFNGLTRACKMATRIXNVPROC, glTrackMatrixNV);
		WGLGETPROC( PFNGLVERTEXATTRIBPOINTERNVPROC, glVertexAttribPointerNV);	
		WGLGETPROC( PFNGLVERTEXATTRIB1FNVPROC, glVertexAttrib1fNV);
		WGLGETPROC( PFNGLVERTEXATTRIB2FNVPROC, glVertexAttrib2fNV);
		WGLGETPROC( PFNGLVERTEXATTRIB3FNVPROC, glVertexAttrib3fNV);
		WGLGETPROC( PFNGLVERTEXATTRIB4FNVPROC, glVertexAttrib4fNV);
		WGLGETPROC( PFNGLVERTEXATTRIB4UBNVPROC,	glVertexAttrib4ubNV);
		WGLGETPROC( PFNGLVERTEXATTRIB1FVNVPROC, glVertexAttrib1fvNV);
		WGLGETPROC( PFNGLVERTEXATTRIB2FVNVPROC,	glVertexAttrib2fvNV);
		WGLGETPROC( PFNGLVERTEXATTRIB3FVNVPROC,	glVertexAttrib3fvNV);
		WGLGETPROC( PFNGLVERTEXATTRIB4FVNVPROC,	glVertexAttrib4fvNV);
		WGLGETPROC( PFNGLVERTEXATTRIB4UBVNVPROC, glVertexAttrib4ubvNV);
		WGLGETPROC( PFNGLVERTEXATTRIBS1FVNVPROC, glVertexAttribs1fvNV);
		WGLGETPROC( PFNGLVERTEXATTRIBS2FVNVPROC, glVertexAttribs2fvNV);
		WGLGETPROC( PFNGLVERTEXATTRIBS3FVNVPROC, glVertexAttribs3fvNV);
		WGLGETPROC( PFNGLVERTEXATTRIBS4FVNVPROC, glVertexAttribs4fvNV);
		WGLGETPROC( PFNGLVERTEXATTRIBS4UBVNVPROC, glVertexAttribs4ubvNV);
	}	 


	if (wglIsExtensionSupported("GL_NV_register_combiners"))
	{
		WGLGETPROC( PFNGLCOMBINERPARAMETERFVNVPROC, glCombinerParameterfvNV);
		WGLGETPROC( PFNGLCOMBINERPARAMETERIVNVPROC, glCombinerParameterivNV);
		WGLGETPROC( PFNGLCOMBINERPARAMETERFNVPROC, glCombinerParameterfNV);
		WGLGETPROC( PFNGLCOMBINERPARAMETERINVPROC, glCombinerParameteriNV);
		WGLGETPROC( PFNGLCOMBINERINPUTNVPROC, glCombinerInputNV);
		WGLGETPROC( PFNGLCOMBINEROUTPUTNVPROC, glCombinerOutputNV);
		WGLGETPROC( PFNGLFINALCOMBINERINPUTNVPROC, glFinalCombinerInputNV);
		WGLGETPROC( PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC, glGetCombinerInputParameterfvNV);
		WGLGETPROC( PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC, glGetCombinerInputParameterivNV);
		WGLGETPROC( PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC, glGetCombinerOutputParameterfvNV);
		WGLGETPROC( PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC, glGetCombinerOutputParameterivNV);
		WGLGETPROC( PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC, glGetFinalCombinerInputParameterfvNV);
		WGLGETPROC( PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC, glGetFinalCombinerInputParameterivNV);
	}

    if (wglIsExtensionSupported("GL_NV_vertex_array_range")) 
	{   
		WGLGETPROC( PFNGLFLUSHVERTEXARRAYRANGENVPROC, glFlushVertexArrayRangeNV);
		WGLGETPROC( PFNGLVERTEXARRAYRANGENVPROC, glVertexArrayRangeNV);
		WGLGETPROC( PFNWGLALLOCATEMEMORYNVPROC, wglAllocateMemoryNV);
		WGLGETPROC( PFNWGLFREEMEMORYNVPROC, wglFreeMemoryNV);

		if (wglIsExtensionSupported("GL_NV_fence")) 
		{
			WGLGETPROC( PFNGLGENFENCESNVPROC, glGenFencesNV);
			WGLGETPROC( PFNGLDELETEFENCESNVPROC, glDeleteFencesNV);
			WGLGETPROC( PFNGLSETFENCENVPROC, glSetFenceNV);
			WGLGETPROC( PFNGLTESTFENCENVPROC, glTestFenceNV);
			WGLGETPROC( PFNGLFINISHFENCENVPROC,	glFinishFenceNV);
			WGLGETPROC( PFNGLISFENCENVPROC,	glIsFenceNV);
			WGLGETPROC( PFNGLGETFENCEIVNVPROC, glGetFenceivNV);		
		}
	}


	return;
}
